(in-package  :custom)
(use-package :oli)

(sd-defdialog 'normteile
  :dialog-title "Normteile"
  :toolbox-button t
  :after-initialization
  '(progn
     (setf normteileliste nil)
  )
  :variables
  '((baugruppe
      :value-type :assembly
      :modifies nil
      :size :third
      :title "Baugr.:"
      :initial-value nil
      :prompt-text "Baugruppe angeben."
      :after-input
      (progn
        (normteileliste-erstellen)
      )
    )
    (anzahl
      :value-type :display-only
      :display-units :string
      :title "Anzahl:"
      :size :third
    )
    ("Darstellungsliste")
    (ausfuehren_1
      :title "Alles anzeigen"
      :toggle-type :wide-toggle
      :push-action
      (progn
        (sd-call-cmds (uic_draw_all (oli::sd-inq-current-vp)))
        (fit_vp (oli::sd-inq-current-vp))
      )
    )
    ("Optionen")
    (ausfuehren_2
      :title "Normteile ausblenden"
      :toggle-type :wide-toggle
      :push-action
      (progn
        (dolist (obj normteileliste)
          (sd-call-cmds (remove_from_vp_drawlist (oli::sd-inq-current-vp) obj))
        )
        (fit_vp (oli::sd-inq-current-vp))
      )
    )
    (ausfuehren_3
      :title "Normteile zeigen"
      :toggle-type :wide-toggle
      :push-action
      (progn
        (remove_from_vp_drawlist (oli::sd-inq-current-vp) :recursive :all_at_top)
        (dolist (obj normteileliste)
          (sd-call-cmds (add_to_vp_drawlist (oli::sd-inq-current-vp) obj))
        )
        (fit_vp (oli::sd-inq-current-vp))
      )
    )
    (ausfuehren_4
      :title "Normteile lschen"
      :toggle-type :wide-toggle
      :push-action
      (progn
        (dolist (obj normteileliste)
          (sd-call-cmds (delete_3d obj))
        )
        (fit_vp (oli::sd-inq-current-vp))
      )
    )
  )
  :local-functions
  '((normteileliste-erstellen ()
      (let ()
        (progn
          (setf normteileliste nil)
          (setf normteileliste
            (sd-call-cmds
              (get_selection
                :focus_type (list *sd-part-seltype* *sd-assembly-seltype*)
                :check_function #'(lambda (obj)
                                    ;; Nach diesen Kriterien werden die Normteile erfasst !!
                                    (if (sd-inq-item-attribute obj "SOLLIB-INFO" :LIBRARY-TYPE :attachment :contents)
                                      :ok
                                      :filter
                                    )
                                  )
                :select :recursive :in_assembly baugruppe
              )
              :failure (sd-display-error (format nil "~a => Bei Erstellen der Normteileliste." (sd-inq-error-obj :message)))
            )
          )
          (setf anzahl (list-length normteileliste))
          (setf anzahl (format nil "~a Stck" anzahl))
        )
      )
    )
  )
  :ok-action
  '()
)
